diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorShader.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorShader.java
index 82a565cf2..a345f7fea 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorShader.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorShader.java
@@ -7,14 +7,14 @@ import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL41;
 
 public class TessellatorShader extends TessellatorBase implements TessellatorGeneral{
-
+    private static final int MASK_ENABLE_COLOR = 0b0000_0001;
+    private static final int MASK_ENABLE_TEXTURE = 0b0000_0010;
+    private static final int MASK_ENABLE_LIGHTMAP = 0b0000_0100;
+    private static final int MASK_ENABLE_NORMAL = 0b0000_1000;
     private boolean lockColor = false;
     private boolean quadEmulation = false;
 
-    private boolean enableColor;
-    private boolean enableTexture;
-    private boolean enableLightmap;
-    private boolean enableNormal;
+    public byte config = 0;
 
     private int color;
     private int lightmap;
@@ -26,15 +26,25 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
     private byte normalY;
     private byte normalZ;
 
-    public final int vao;
-    public final int vbo;
+    // Pre-setup all possible configs since total permutations is fairly low and this tessellator is used throughout
+    public final int[] vaos = new int[16]; // Holds vertex array objects for each possible configuration
+    public final int[] vbos = new int[16]; // Holds buffers for each possible configuration
 
     private int quadVertCount = 0;
 
     public TessellatorShader(@NotNull String name, int initialCapacity) {
         super(name, initialCapacity);
-        this.vao = GL41.glGenVertexArrays();
-        this.vbo = GL41.glGenBuffers();
+        GL41.glGenVertexArrays(this.vaos);
+        GL41.glGenBuffers(this.vbos);
+
+        for (int i = 0; i < 16; i++) {
+            enableVertexAttribs(this.vaos[i], this.vbos[i],
+                (i & MASK_ENABLE_COLOR) != 0,
+                (i & MASK_ENABLE_TEXTURE) != 0,
+                (i & MASK_ENABLE_LIGHTMAP) != 0,
+                (i & MASK_ENABLE_NORMAL) != 0);
+            GL41.glBindVertexArray(0);
+        }
     }
 
     @Override
@@ -42,10 +52,7 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
         super.startDrawing(drawMode);
 
         this.lockColor = false;
-        this.enableColor = false;
-        this.enableTexture = false;
-        this.enableLightmap = false;
-        this.enableNormal = false;
+        this.config = 0;
 
         this.quadEmulation = drawMode == DrawMode.QUADS && Tessellator.QUAD_EMULATION;
         if (this.quadEmulation) {
@@ -63,21 +70,21 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
         this.data.putFloat((float) (this.offsetY + y));
         this.data.putFloat((float) (this.offsetZ + z));
 
-        if(this.enableColor) {
+        if((this.config & MASK_ENABLE_COLOR) != 0) {
             this.data.putInt(this.color);
         }
 
-        if(this.enableTexture) {
+        if((this.config & MASK_ENABLE_TEXTURE) != 0) {
             this.data.putFloat(this.texU);
             this.data.putFloat(this.texV);
         }
 
-        if(this.enableLightmap) {
+        if((this.config & MASK_ENABLE_LIGHTMAP) != 0) {
             this.data.put((byte) ((LightmapHelper.getBlockLightFromCoord(this.lightmap) << 4) + 7));
             this.data.put((byte) ((LightmapHelper.getSkyLightFromCoord(this.lightmap) << 4) + 7));
         }
 
-        if(this.enableNormal) {
+        if((this.config & MASK_ENABLE_NORMAL) != 0) {
             this.data.put(this.normalX);
             this.data.put(this.normalY);
             this.data.put(this.normalZ);
@@ -85,7 +92,10 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
         this.vertexCount++;
 
         if (this.quadEmulation && this.quadVertCount % 4 == 2) {
-            int vertSize = getVertexSize();
+            int vertSize = getVertexSize((this.config & MASK_ENABLE_COLOR) != 0,
+                (this.config & MASK_ENABLE_TEXTURE) != 0,
+                (this.config & MASK_ENABLE_LIGHTMAP) != 0,
+                (this.config & MASK_ENABLE_NORMAL) != 0);
 
             checkCanFit(128);
             this.data.put(this.data.position(), this.data, this.data.position() - vertSize * 3, vertSize);
@@ -109,12 +119,12 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
         if (this.lockColor) {
             return;
         }
-        if (!this.enableColor) {
+        if ((this.config & MASK_ENABLE_COLOR) == 0) {
             if (this.vertexCount > 0) {
                 this.drawing = false;
                 throw new IllegalStateException(this.name + " color is disabled!");
             }
-            this.enableColor = true;
+            this.config |= MASK_ENABLE_COLOR;
         }
 
         int a = (argb >> 24) & 0xFF;
@@ -128,12 +138,12 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
     @Override
     public void setTextureUV(double u, double v) {
         checkIsDrawing();
-        if (!this.enableTexture) {
+        if ((this.config & MASK_ENABLE_TEXTURE) == 0) {
             if (this.vertexCount > 0) {
                 this.drawing = false;
                 throw new IllegalStateException(this.name + " texture is disabled!");
             }
-            this.enableTexture = true;
+            this.config |= MASK_ENABLE_TEXTURE;
         }
 
         this.texU = (float) u;
@@ -143,12 +153,12 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
     @Override
     public void setLightmapCoord1i(int lightmapCoord) {
         checkIsDrawing();
-        if (!this.enableLightmap) {
+        if ((this.config & MASK_ENABLE_LIGHTMAP) == 0) {
             if (this.vertexCount > 0) {
                 this.drawing = false;
                 throw new IllegalStateException(this.name + " lightmap is disabled!");
             }
-            this.enableLightmap = true;
+            this.config |= MASK_ENABLE_LIGHTMAP;
         }
 
         this.lightmap = lightmapCoord;
@@ -157,12 +167,12 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
     @Override
     public void setNormal(float x, float y, float z) {
         checkIsDrawing();
-        if (!this.enableNormal) {
+        if ((this.config & MASK_ENABLE_NORMAL) == 0) {
             if (this.vertexCount > 0) {
                 this.drawing = false;
                 throw new IllegalStateException(this.name + " normal is disabled!");
             }
-            this.enableNormal = true;
+            this.config |= MASK_ENABLE_NORMAL;
         }
 
         this.normalX = (byte) (x * 127.0f);
@@ -177,9 +187,18 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
 
         if (this.vertexCount == 0) return;
 
-        enableVertexAttribs(this.vao, this.vbo);
+        enableBufferedConfig(this.vaos[this.config], this.vbos[this.config],
+            (this.config & MASK_ENABLE_COLOR) != 0,
+            (this.config & MASK_ENABLE_TEXTURE) != 0,
+            (this.config & MASK_ENABLE_LIGHTMAP) != 0,
+            (this.config & MASK_ENABLE_NORMAL) != 0);
         GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STREAM_DRAW);
-        GLRenderer.render(this.vao, this.vbo, 0, this.vertexCount, this.drawMode);
+
+        GLRenderer.getShader().bind();
+        GLRenderer.globalSetUniforms(GLRenderer.getShader());
+        GL41.glDrawArrays(this.drawMode.cap, 0, this.vertexCount);
+        GL41.glUseProgram(0);
+        GL41.glBindVertexArray(0);
     }
 
     @Override
@@ -193,18 +212,18 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
         return new RenderBuffer(vao, vbo, 0, this.vertexCount, this.drawMode);
     }
 
-    protected int getVertexSize() {
+    protected int getVertexSize(boolean color, boolean texture, boolean lightmap, boolean normal) {
         int size = Float.BYTES * 3;
-        if(this.enableColor) {
+        if(color) {
             size += 4;
         }
-        if(this.enableTexture) {
+        if(texture) {
             size += Float.BYTES * 2;
         }
-        if(this.enableNormal) {
+        if(normal) {
             size += 3;
         }
-        if(this.enableLightmap) {
+        if(lightmap) {
             size += 2;
         }
 
@@ -212,41 +231,59 @@ public class TessellatorShader extends TessellatorBase implements TessellatorGen
     }
 
     protected void enableVertexAttribs(int vao, int vbo) {
+        enableVertexAttribs(vao, vbo, (this.config & MASK_ENABLE_COLOR) != 0, (this.config & MASK_ENABLE_TEXTURE) != 0, (this.config & MASK_ENABLE_LIGHTMAP) != 0, (this.config & MASK_ENABLE_NORMAL) != 0);
+    }
+
+    protected void enableVertexAttribs(int vao, int vbo, boolean color, boolean texture, boolean lightmap, boolean normal) {
         GL41.glBindVertexArray(vao);
         GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, vbo);
 
-        int vertexSize = getVertexSize();
+        int vertexSize = getVertexSize(color, texture, lightmap, normal);
         int offset = 0;
         GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, vertexSize, offset); offset += 3 * Float.BYTES;    // Pos
         GL41.glEnableVertexAttribArray(0);
-        if (this.enableColor) {
+        if (color) {
             GL41.glVertexAttribPointer(1, 4, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 4;    // Color
             GL41.glEnableVertexAttribArray(1);
         } else {
             GL41.glDisableVertexAttribArray(1);
-            GL41.glVertexAttrib4f(1, 1f, 1f, 1f, 1f);
         }
 
-        if (this.enableTexture) {
+        if (texture) {
             GL41.glVertexAttribPointer(2, 2, GL41.GL_FLOAT, false, vertexSize, offset); offset += 2 * Float.BYTES;    // UV
             GL41.glEnableVertexAttribArray(2);
         } else {
             GL41.glDisableVertexAttribArray(2);
         }
 
-        if (this.enableLightmap) {
+        if (lightmap) {
             GL41.glVertexAttribPointer(3, 2, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 2;    // Lightmap
             GL41.glEnableVertexAttribArray(3);
         } else {
             GL41.glDisableVertexAttribArray(3);
-            GL41.glVertexAttrib2f(3, GLRenderer.getLightmapBlock(), GLRenderer.getLightmapSky());
         }
 
-        if (this.enableNormal) {
+        if (normal) {
             GL41.glVertexAttribPointer(4, 3, GL41.GL_BYTE, true, vertexSize, offset); offset += 3;    // Normal
             GL41.glEnableVertexAttribArray(4);
         } else {
             GL41.glDisableVertexAttribArray(4);
+        }
+    }
+
+    protected void enableBufferedConfig(int vao, int vbo, boolean color, boolean texture, boolean lightmap, boolean normal) {
+        GL41.glBindVertexArray(vao);
+        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, vbo);
+
+        if (!color) {
+            GL41.glVertexAttrib4f(1, 1f, 1f, 1f, 1f);
+        }
+
+        if (!lightmap) {
+            GL41.glVertexAttrib2f(3, GLRenderer.getLightmapBlock(), GLRenderer.getLightmapSky());
+        }
+
+        if (!normal) {
             GL41.glVertexAttrib3f(4, 0, -1, 0);
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
index ddab17cb8..74d1e7ac7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
@@ -19,7 +19,6 @@ import net.minecraft.core.block.piston.BlockLogicPistonHead;
 import net.minecraft.core.block.piston.TileEntityMovingPistonBlock;
 import net.minecraft.core.world.BlocksContainer;
 import net.minecraft.core.world.pos.TilePos;
-import org.lwjgl.opengl.GL11;
 
 public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntityMovingPistonBlock> {
     private final Minecraft mc;
@@ -44,11 +43,6 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
             GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
             GLRenderer.enableState(State.BLEND);
             GLRenderer.disableState(State.CULL_FACE);
-            if (this.mc.isAmbientOcclusionEnabled()) {
-                GL11.glShadeModel(GL11.GL_SMOOTH);
-            } else {
-                GL11.glShadeModel(GL11.GL_FLAT);
-            }
             tessellator.startDrawingQuads();
             tessellator.setTranslation(((float) x - (float) tileEntity.x) + tileEntity.getXOff(partialTick), ((float) y - (float) tileEntity.y) + tileEntity.getYOff(partialTick), ((float) z - (float) tileEntity.z) + tileEntity.getZOff(partialTick));
             if (Block.hasLogicClass(block, BlockLogicPistonHead.class) && tileEntity.getProgress(partialTick) < 0.5F) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index d88f1ddb7..844eecd9f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -184,11 +184,6 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
         this.textMeshRenderer.tick();
     }
 
-    @Override
-    public void onWorldChanged(final World world) {
-        this.textMeshRenderer.flushCaches();
-    }
-
     @Override
     public boolean isVisible(@NotNull final TileEntitySign tileEntity, final @NotNull ICamera camera, final float partialTick) {
         return camera.getFrustum().isVisible(new AABBd(tileEntity.x, tileEntity.y, tileEntity.z, tileEntity.x + 1, tileEntity.y + 1, tileEntity.z + 1), partialTick);
@@ -213,17 +208,6 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
             }
         }
 
-        public void flushCaches() {
-            for (final MeshEntry entry : this.bufferedMeshes) {
-                GLAllocation.deleteDisplayList(entry.list);
-            }
-            this.bufferedMeshes.clear();
-            for (final int list : this.freeDisplayLists) {
-                GLAllocation.deleteDisplayList(list);
-            }
-            this.freeDisplayLists.clear();
-        }
-
         public void render(@NotNull final FontRenderer sr,
                            @NotNull final TessellatorGeneral t,
                            @NotNull final CharSequence line1,
@@ -281,14 +265,6 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
 
         }
 
-        private int getDisplayList() {
-            if (this.freeDisplayLists.isEmpty()) {
-                return GLAllocation.generateDisplayLists(1);
-            } else {
-                return this.freeDisplayLists.removeInt(0);
-            }
-        }
-
         public static class MeshEntry {
             public long config;
             public @NotNull String line1;
diff --git a/game/client/src/main/java/net/minecraft/client/render/uniform/BufferAdapter.java b/game/client/src/main/java/net/minecraft/client/render/uniform/BufferAdapter.java
new file mode 100644
index 000000000..8e0d39461
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/uniform/BufferAdapter.java
@@ -0,0 +1,9 @@
+package net.minecraft.client.render.uniform;
+
+import org.jetbrains.annotations.NotNull;
+
+import java.nio.ByteBuffer;
+
+public interface BufferAdapter<T> {
+    @NotNull ByteBuffer bufferData(T src, int offset, @NotNull ByteBuffer dest);
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/uniform/UniformBlock.java b/game/client/src/main/java/net/minecraft/client/render/uniform/UniformBlock.java
new file mode 100644
index 000000000..495d57069
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/uniform/UniformBlock.java
@@ -0,0 +1,31 @@
+package net.minecraft.client.render.uniform;
+
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.BufferUtils;
+import org.lwjgl.opengl.GL41;
+
+import java.nio.ByteBuffer;
+
+public class UniformBlock<T> {
+    public static final int N = 4; // GL operates in multiples of 4 bytes for everything
+    public final @NotNull String name;
+    public final int index;
+    public final int ubo;
+    public final @NotNull ByteBuffer buffer;
+    public final @NotNull BufferAdapter<T> adapter;
+
+    public UniformBlock(@NotNull String name, int index, int size, @NotNull BufferAdapter<T> adapter) {
+        assert size % N == 0 : "Size must be a multiple of GL's uniform slot size!";
+        this.name = name;
+        this.index = index;
+        this.adapter = adapter;
+        this.buffer = BufferUtils.createByteBuffer(size);
+
+        this.ubo = GL41.glGenBuffers();
+        GL41.glBindBuffer(GL41.GL_UNIFORM_BUFFER, this.ubo);
+        GL41.glBufferData(GL41.GL_UNIFORM_BUFFER, size, GL41.GL_DYNAMIC_DRAW);
+        GL41.glBindBuffer(GL41.GL_UNIFORM_BUFFER, 0);
+
+        GL41.glBindBufferRange(GL41.GL_UNIFORM_BUFFER, index, this.ubo, 0, size);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/uniform/UniformBlockManager.java b/game/client/src/main/java/net/minecraft/client/render/uniform/UniformBlockManager.java
new file mode 100644
index 000000000..8a691c93e
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/uniform/UniformBlockManager.java
@@ -0,0 +1,38 @@
+package net.minecraft.client.render.uniform;
+
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
+import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
+import net.minecraft.client.render.FogManager;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Matrix4f;
+
+import java.nio.ByteBuffer;
+import java.util.Map;
+
+import static net.minecraft.client.render.uniform.UniformBlock.N;
+
+public class UniformBlockManager {
+    public static final @NotNull Map<String, UniformBlock<?>> nameToBlockMap = new Object2ObjectOpenHashMap<>();
+    public static final @NotNull Int2ObjectMap<UniformBlock<?>> indexToBlockMap = new Int2ObjectOpenHashMap<>();
+
+    public static final @NotNull UniformBlock<Matrix4f> BLOCK_MATRICES = register("Matrices", 0, N * 4 * 4 * 4, Matrix4f::get);
+    public static final @NotNull UniformBlock<FogManager.FogState> BLOCK_FOG_STATE = register("FogState", 1, FogManager.FogState.uboSize(), new BufferAdapter<FogManager.FogState>() {
+        @Override
+        public @NotNull ByteBuffer bufferData(FogManager.FogState src, int offset, @NotNull ByteBuffer dest) {
+            src.fogColor.get(offset, dest); offset += N * 4;
+            dest.putInt(offset, src.fogMode.ordinal()); offset += N;
+            dest.putFloat(offset, src.fogStart); offset += N;
+            dest.putFloat(offset, src.fogEnd); offset += N;
+            dest.putFloat(offset, src.fogDensity); offset += N;
+            return dest;
+        }
+    });
+
+    public static <T> UniformBlock<T> register(@NotNull String name, int index, int size, @NotNull BufferAdapter<T> adapter) {
+        UniformBlock<T> block = new UniformBlock<>(name, index, size, adapter);
+        nameToBlockMap.put(name, block);
+        indexToBlockMap.put(index, block);
+        return block;
+    }
+}
diff --git a/game/client/src/main/resources/shaders/clouds.fsh b/game/client/src/main/resources/shaders/clouds.fsh
index 00746bf35..dcaad24a3 100644
--- a/game/client/src/main/resources/shaders/clouds.fsh
+++ b/game/client/src/main/resources/shaders/clouds.fsh
@@ -3,26 +3,39 @@
 #define FOG
 #define RADIAL_FOG
 
-uniform int isEyeInLiquid;
-
-uniform mat4 projectionInv;
-uniform float viewWidth;
-uniform float viewHeight;
-
 in vec4 Color;
 in vec2 TexCoord;
 
 out vec4 FragColor;
 
-uniform vec4 ufogColor;
-uniform int ufogMode;
-uniform float ufogStart;
-uniform float ufogEnd;
-uniform float ufogDensity;
+layout (std140) uniform FogState {
+	vec4 color;
+	int mode;
+	float start;
+	float end;
+	float density;
+} fogState;
+
+layout (std140) uniform Matrices {
+	mat4 projection;
+	mat4 projectionInv;
+	mat4 view;
+	mat4 viewInv;
+} matrices;
+
+uniform int isEyeInLiquid;
+uniform vec2 uViewPortSize;
 
 uniform sampler2D texture0;
 uniform sampler2D texture1;
 
+float distance() {
+	vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0f - 1.0f, gl_FragCoord.z * 2.0f - 1.0f, 1.0f);
+	fragPos /= fragPos.w;
+
+	return length(fragPos.xyz);
+}
+
 void main() {
 	vec4 tex = texture(texture0, TexCoord);
 	
@@ -40,14 +53,10 @@ void main() {
 
 	float fogStrength = 0.0f;
 
-	vec4 fragPos = projectionInv * vec4((gl_FragCoord.xy / vec2(viewWidth, viewHeight)) * 2.0f - 1.0f, gl_FragCoord.z * 2.0f - 1.0f, 1.0f);
-	fragPos /= fragPos.w;
-	
-	float dist = length(fragPos.xyz);
-	float end = (ufogEnd * 1.5f);
-	float start = ufogStart / (ufogEnd * 1.5f);
+	float end = (fogState.end * 1.5f);
+	float start = fogState.start / (fogState.end * 1.5f);
 
-	fogStrength = dist / end;
+	fogStrength = distance() / end;
 	fogStrength -= start;
 	fogStrength /= (1.0f - start);
 	fogStrength = clamp(fogStrength, 0.0f, 1.0f);
diff --git a/game/client/src/main/resources/shaders/clouds.vsh b/game/client/src/main/resources/shaders/clouds.vsh
index ec9b57fd0..cb437bb97 100644
--- a/game/client/src/main/resources/shaders/clouds.vsh
+++ b/game/client/src/main/resources/shaders/clouds.vsh
@@ -9,12 +9,17 @@ out vec4 Color;
 out vec2 TexCoord;
 
 uniform mat4 model;
-uniform mat4 view;
-uniform mat4 projection;
+
+layout (std140) uniform Matrices {
+	mat4 projection;
+	mat4 projectionInv;
+	mat4 view;
+	mat4 viewInv;
+} matrices;
 
 void main() {
 	TexCoord = aUV;
 	Color = aColor;
 
-	gl_Position = projection * view * model * vec4(aPos, 1);
+	gl_Position = matrices.projection * matrices.view * model * vec4(aPos, 1);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/color.fsh b/game/client/src/main/resources/shaders/color.fsh
index a0dabc0a1..b2645ee5e 100644
--- a/game/client/src/main/resources/shaders/color.fsh
+++ b/game/client/src/main/resources/shaders/color.fsh
@@ -4,8 +4,8 @@ out vec4 FragColor;
 
 in vec4 Color;
 
-uniform vec4 ucolor;
+uniform vec4 uColor;
 
 void main() {
-    FragColor = Color * ucolor;
+    FragColor = Color * uColor;
 }
diff --git a/game/client/src/main/resources/shaders/color.vsh b/game/client/src/main/resources/shaders/color.vsh
index 963b1691f..c4ea49571 100644
--- a/game/client/src/main/resources/shaders/color.vsh
+++ b/game/client/src/main/resources/shaders/color.vsh
@@ -5,10 +5,15 @@ layout (location = 1) in vec4 aColor;
 out vec4 Color;
 
 uniform mat4 model;
-uniform mat4 view;
-uniform mat4 projection;
+
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
 
 void main() {
-    gl_Position = projection * view * model * vec4(aPos, 1);
+    gl_Position = matrices.projection * matrices.view * model * vec4(aPos, 1);
     Color = aColor;
 }
diff --git a/game/client/src/main/resources/shaders/color_world.fsh b/game/client/src/main/resources/shaders/color_world.fsh
index a3c438d38..dcfc19dd5 100644
--- a/game/client/src/main/resources/shaders/color_world.fsh
+++ b/game/client/src/main/resources/shaders/color_world.fsh
@@ -4,53 +4,69 @@ out vec4 FragColor;
 
 in vec4 Color;
 in vec2 LightMapCoord;
-in float Distance;
 in vec3 Light;
 
-uniform vec4 ucolor;
+uniform vec4 uColor;
+uniform vec2 uViewPortSize;
 
-uniform vec4 ufogColor;
-uniform int ufogMode;
-uniform float ufogStart;
-uniform float ufogEnd;
-uniform float ufogDensity;
+layout (std140) uniform FogState {
+    vec4 color;
+    int mode;
+    float start;
+    float end;
+    float density;
+} fogState;
+
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
 
 uniform sampler2D texture1;
 
+float distance() {
+    vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0f - 1.0f, gl_FragCoord.z * 2.0f - 1.0f, 1.0f);
+    fragPos /= fragPos.w;
+
+    return length(fragPos.xyz);
+}
+
 // Taken from https://github.com/hughsk/glsl-fog
 float fogFactorLinear() {
-    return 1.0 - clamp(((ufogEnd - (Distance)) / (ufogEnd - ufogStart)), 0.0, 1.0);
+    return 1.0 - clamp(((fogState.end - (distance())) / (fogState.end - fogState.start)), 0.0, 1.0);
 }
 
 float fogFactorExp() {
-    return 1.0 - clamp(exp(-ufogDensity * (Distance)), 0.0, 1.0);
+    return 1.0 - clamp(exp(-fogState.density * (distance())), 0.0, 1.0);
 }
 
 float fogFactorExp2() {
     float LOG2 = -1.442695;
-    float d = ufogDensity * (Distance);
+    float d = fogState.density * (distance());
     return 1.0 - clamp(exp2(d * d * LOG2), 0.0, 1.0);
 }
 
 
 vec4 computeFog(vec4 color) {
     float f = 0;
-    if (ufogMode == 0) { // Linear
+    if (fogState.mode == 0) { // Linear
         f = fogFactorLinear();
     }
-    else if (ufogMode == 1) { // EXP
+    else if (fogState.mode == 1) { // EXP
         f = fogFactorExp();
     }
-    else if (ufogMode == 2) { // EXP2
+    else if (fogState.mode == 2) { // EXP2
         f = fogFactorExp2();
     }
-    return vec4(mix(color.rgb, ufogColor.rgb, f), color.a);
+    return vec4(mix(color.rgb, fogState.color.rgb, f), color.a);
 }
 
 void main() {
     vec4 lightColor = texture(texture1, LightMapCoord);
 
-    vec4 oColor = lightColor * Color * ucolor;
+    vec4 oColor = lightColor * Color * uColor;
     vec4 litColor = vec4(oColor.rgb * clamp(Light, 0, 1), oColor.a);
 
     FragColor = computeFog(oColor);
diff --git a/game/client/src/main/resources/shaders/color_world.vsh b/game/client/src/main/resources/shaders/color_world.vsh
index 6eec498b0..d6403f084 100644
--- a/game/client/src/main/resources/shaders/color_world.vsh
+++ b/game/client/src/main/resources/shaders/color_world.vsh
@@ -7,7 +7,6 @@ layout (location = 4) in vec3 aNormal;
 out vec4 Color;
 out vec2 TexCoord;
 out vec2 LightMapCoord;
-out float Distance;
 out vec3 Light;
 
 uniform mat4 normalTransform;
@@ -16,19 +15,20 @@ uniform vec4 lightSourcePosition[];
 uniform vec4 lightSourceDiffuse[];
 
 uniform mat4 model;
-uniform mat4 view;
-uniform mat4 projection;
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
 
 void main() {
     vec4 p = vec4(aPos, 1);
-    gl_Position = projection * view * model * p;
+    gl_Position = matrices.projection * matrices.view * model * p;
 
     Color = aColor;
     LightMapCoord = aLightmap;
 
-    // Used for the radial fog in shader
-    Distance = length((view * model * p).xyz);
-
     vec4 norm = normalize(normalTransform * model * vec4(aNormal, 0));
     float dir1 = max(0.0f, dot(norm, lightSourcePosition[0]));
     float dir2 = max(0.0f, dot(norm, lightSourcePosition[1]));
diff --git a/game/client/src/main/resources/shaders/font.fsh b/game/client/src/main/resources/shaders/font.fsh
index 969fa5cdb..b347f8cba 100644
--- a/game/client/src/main/resources/shaders/font.fsh
+++ b/game/client/src/main/resources/shaders/font.fsh
@@ -5,13 +5,13 @@ in vec4 Color;
 in vec2 TexCoord;
 in vec2 Lightmap;
 
-uniform vec4 ucolor;
+uniform vec4 uColor;
 
 uniform sampler2D texture0;
 uniform sampler2D texture1;
 
 void main() {
-    FragColor = texture(texture0, TexCoord) * texture(texture1, Lightmap) * Color * ucolor;
+    FragColor = texture(texture0, TexCoord) * texture(texture1, Lightmap) * Color * uColor;
     if (FragColor.a < 0.1f) {
         discard;
     }
diff --git a/game/client/src/main/resources/shaders/font.gsh b/game/client/src/main/resources/shaders/font.gsh
index 0cf0dc235..c3c377ebc 100644
--- a/game/client/src/main/resources/shaders/font.gsh
+++ b/game/client/src/main/resources/shaders/font.gsh
@@ -16,27 +16,31 @@ out vec2 TexCoord;
 out vec2 Lightmap;
 
 uniform mat4 model;
-uniform mat4 view;
-uniform mat4 projection;
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
 
 void main() {
     Color = gs_in[0].color;
     Lightmap = gs_in[0].lightmap;
 
     TexCoord = gs_in[0].uv + vec2(0, gs_in[0].uvSizes.y);
-    gl_Position = projection * view * model * (gl_in[0].gl_Position + vec4(-gs_in[0].shift,  gs_in[0].size.y, 0.0, 0.0));
+    gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(-gs_in[0].shift,  gs_in[0].size.y, 0.0, 0.0));
     EmitVertex();
 
     TexCoord = gs_in[0].uv + vec2(gs_in[0].uvSizes.x, gs_in[0].uvSizes.y);
-    gl_Position = projection * view * model * (gl_in[0].gl_Position + vec4(gs_in[0].size.x - gs_in[0].shift,  gs_in[0].size.y, 0.0, 0.0));
+    gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(gs_in[0].size.x - gs_in[0].shift,  gs_in[0].size.y, 0.0, 0.0));
     EmitVertex();
 
     TexCoord = gs_in[0].uv + vec2(0, 0);
-    gl_Position = projection * view * model * (gl_in[0].gl_Position + vec4(gs_in[0].shift, 0, 0.0, 0.0));
+    gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(gs_in[0].shift, 0, 0.0, 0.0));
     EmitVertex();
 
     TexCoord = gs_in[0].uv + vec2(gs_in[0].uvSizes.x, 0);
-    gl_Position = projection * view * model * (gl_in[0].gl_Position + vec4(gs_in[0].size.x + gs_in[0].shift, 0, 0.0, 0.0));
+    gl_Position = matrices.projection * matrices.view * model * (gl_in[0].gl_Position + vec4(gs_in[0].size.x + gs_in[0].shift, 0, 0.0, 0.0));
     EmitVertex();
 
     EndPrimitive();
diff --git a/game/client/src/main/resources/shaders/font.vsh b/game/client/src/main/resources/shaders/font.vsh
index 3c9e8bb1a..a8f45ac77 100644
--- a/game/client/src/main/resources/shaders/font.vsh
+++ b/game/client/src/main/resources/shaders/font.vsh
@@ -24,7 +24,7 @@ void main() {
     vs_out.size = aSize;
     vs_out.shift = aShift;
     vs_out.color = aColor;
-    vs_out.uv = aUv;
-    vs_out.uvSizes = aUvSizes;
+    vs_out.uv = aUv/256f;
+    vs_out.uvSizes = aUvSizes/256f;
     vs_out.lightmap = aLightmap;
 }
diff --git a/game/client/src/main/resources/shaders/interface.fsh b/game/client/src/main/resources/shaders/interface.fsh
index ded77c9ca..8017968fb 100644
--- a/game/client/src/main/resources/shaders/interface.fsh
+++ b/game/client/src/main/resources/shaders/interface.fsh
@@ -5,9 +5,9 @@ out vec4 FragColor;
 in vec4 Color;
 in vec2 TexCoord;
 
-uniform vec4 ucolor;
+uniform vec4 uColor;
 uniform sampler2D texture0;
 
 void main() {
-    FragColor = texture(texture0, TexCoord) * Color * ucolor;
+    FragColor = texture(texture0, TexCoord) * Color * uColor;
 }
diff --git a/game/client/src/main/resources/shaders/interface.vsh b/game/client/src/main/resources/shaders/interface.vsh
index 1df6d673c..f01aa4cf6 100644
--- a/game/client/src/main/resources/shaders/interface.vsh
+++ b/game/client/src/main/resources/shaders/interface.vsh
@@ -7,11 +7,15 @@ out vec4 Color;
 out vec2 TexCoord;
 
 uniform mat4 model;
-uniform mat4 view;
-uniform mat4 projection;
+layout (std140) uniform Matrices {
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
+} matrices;
 
 void main() {
-    gl_Position = projection * view * model * vec4(aPos, 1);
+    gl_Position = matrices.projection * matrices.view * model * vec4(aPos, 1);
 
     TexCoord = aUV;
     Color = aColor;
